#!/bin/bash

Filename=$1     #拼接文件名
Subfilenum=$2   #拼接文件个数

#输入合并后文件命名
if [ -z $Filename ];then
    echo "Error:File name can not be empty"
    exit
fi

#输入待合并文件的个数
if [ -z $Subfilenum ];then
    echo "Error:The number of subfiles can not be empty"
    exit
fi
echo $Subfilenum | grep '^[0-9]\+$' > /dev/null   #只支持最大9个文件（改成一天12个）

if [ $? -ne 0 ];then
    echo "Error:Input must be a number"
    exit
fi

if [ $Subfilenum -eq 0 ];then
    echo "Error:The number of subfiles can not be zero"
    exit
fi

#合并文件
i=1
Newfile=$Filename    #新文件名称
while [ $i -le $Subfilenum ]
do
    Subfilename=$Filename$i
    if [ -e $Subfilename ];then
        #echo "$Subfilename done!"  #过程信息
        cat $Subfilename >> $Newfile
        i=`expr $i + 1`
    else
        echo "Error:$Subfilename does not exist"
        rm -rf $Newfile
        exit
    fi
done
echo "Subfiles be merged into $Newfile" #最终信息
