#!/usr/bin/python2.7
'''
Created on 2018/6/2

@author: jtao
'''
import getopt
import sys
if __name__ == '__main__':
    usage = "Usage:makeSes.py -f sesfile -l sitlist -o out -m S|K|F --clk FIX -s [GREC] -d sat_del --dztd dztd --qztd qztd --dion dion --qion qion --pgps 2:0.02 --pgal 2:0.02 --pglo 2:0.02 --pcmp 2:0.02"   
    sesfile = ""
    skd = "S"
    osys = "GREC" 
    sitlist=""
    outfile = ""
    satdel = ""
    opts,args = getopt.getopt(sys.argv[1:], "f:l:m:s:o:d:",['clk=','dion=','qion=','pgps=','pgal=','pglo=','pcmp=','pqzs=','dztd=','qztd='])
    if len(opts) == 0:
        print usage
        sys.exit()
    clk = "CLK"
    dion = 20.0
    qion = 20.0
    dztd=0.2
    qztd=0.0004
    rg = rr = re = rc = rj = 2
    pg = pr = pe = pc = pj = 0.02
    for op,value in opts:
        if op == '-f':
            sesfile = value
        elif op == '-l':
            sitlist = value
        elif op == '-m':
            skd = value
        elif op == '-s':
            osys = value
        elif op == "-o":
            outfile = value
        elif op == "-d":
            satdel = value
        elif op == "--clk":
            clk = value;
        elif op == "--dion":
            dion = float(value)
        elif op == "--qion":
            qion = float(value)
        elif op == "--dztd":
            dztd = float(value)
        elif op == "--qztd":
            qztd = float(value)
        elif op == "--pgps":
            v = value.split(':');
            rg = float(v[0]);
            pg = float(v[1]);
        elif op == "--pgal":
            v = value.split(':');
            re = float(v[0]);
            pe = float(v[1]);
        elif op == "--pglo":
            v = value.split(':');
            rr = float(v[0]);
            pr = float(v[1]);
        elif op == "--pcmp":
            v = value.split(':');
            rc = float(v[0]);
            pc = float(v[1]);
        elif op == "--pqzs":
            v = value.split(':');
            rj = float(v[0]);
            pj = float(v[1]);
    
        else:
            print usage
            sys.exit()
    try:
        fid_s = open(sesfile,"r")
        fid_l = open(sitlist,"r")
        fid_w = open(outfile,"w")
        if len(satdel):
            fid_d = open(satdel,"r")
    except:
        print "can't open sesion file %s or sitlist file %s or satdel file %s"%(sesfile,sitlist,satdel)
        sys.exit()
    for line in fid_s:
        if line.find("-Satellite used GNSS") != -1:
            fid_w.write(line)
            break
        if line[0] == ' ':
            if  -1 != osys.find(line[1]):
                if len(satdel):
                    iFind = False
                    fid_d.seek(0)
                    for dline in fid_d:
                        if(-1 != dline.find(line[1:4])):
                            iFind = True
                            break
                    if iFind:
                        fid_w.write("#%s"%line[1:])
                    else:
                        fid_w.write("%s"%line)                
                else:
                    fid_w.write("%s"%line)    
                continue
            else:
                fid_w.write("#%s"%line[1:])
                continue
        fid_w.write(line)    
    fid_w.write("                                        \r\n");
    fid_w.write("                                        \r\n");
    fid_w.write("+Station used = (1x,a4,1x,a2,1x,a4,1x,a3,7(1x,f7.1,f6.1),f5.1,1x,a3,3(f7.3,f6.3),7(f6.3,f6.3))\r\n")
    fid_w.write("*NAME TP PCVs RCLK SIG0/m PD/m   SIG0/m PD/m   SIG0/m PD/m   SIG0/m PD/m   SIG0/m PD/m   SIG0/m PD/m   SIG0/m PD/m  ELEV MAP ZTDS/m ZTDPD GRDS/m GRDPD IONS/m IONPD GRa/m GPh/m RRa/m RPh/m ERa/m EPh/m CRa/m CPh/m SRa/m SPh/m JRa/m JPh/m IRa/m IPh/m\r\n")
    for line in fid_l:
        if len(line) < 4:
            continue;
        sit = []
        if len(line) > 6:
            ## got a rtk part 
            sit = line.split(' ')
        else:
            sit.append(line[0:4])
            sit.append(' ')
        fid_w.write(" %s %c  AZEL %3s  9000.0 900.0  9000.0 900.0  9000.0 900.0  9000.0 900.0  \
9000.0 900.0  9000.0 900.0  9000.0 900.0 7.0 GMF  %6.4f %5.4f  0.010 0.001 %6.3lf %5.3lf %6.3lf \
%5.3lf %6.3lf %5.3lf %6.3lf %5.3lf %6.3lf %5.3lf 2.000 0.020 %6.3lf %5.3lf 2.000 0.020 %s\r\n"%(sit[0][0:4].upper(),skd[0],clk,dztd,qztd,dion,qion,rg,pg,rr,pr,re,pe,rc,pc,rj,pj,sit[1][0:4].upper()))
        if len(sit[1].strip()) > 0:
            fid_w.write(" %s R  AZEL %3s  9000.0 900.0  9000.0 900.0  9000.0 900.0  9000.0 900.0  \
9000.0 900.0  9000.0 900.0  9000.0 900.0 7.0 GMF  %6.4f %5.4f  0.010 0.001 %6.3lf %5.3lf %6.3lf \
%5.3lf %6.3lf %5.3lf %6.3lf %5.3lf %6.3lf %5.3lf 2.000 0.020 %6.3lf %5.3lf 2.000 0.020\r\n"%(sit[1][0:4].upper(),clk,dztd,qztd,dion,qion,rg,pg,rr,pr,re,pe,rc,pc,rj,pj))
    fid_w.write("-Station used\r\n")
    fid_w.close()
    fid_l.close()
    fid_s.close()
    if len(satdel):
        fid_d.close()
    pass
