#!/bin/bash
source globalvar.sh

main() {
    local list=$1

    if [ $# -lt 1 ]; then
        echo "*.sh list"
        exit 1
    fi

    echo ""
    echo "smooth"
    ${bbobindir}/bamboo -mode rtk nrtk.json -post -itrs -smooth >/dev/null 2>&1
    bakiar_list $list ewl

    echo ""
    echo "smooth with ambcons_ewl"
    ${bbobindir}/bamboo -mode rtk nrtk.json -post -itrs -smooth -pams ambcons_ewl >/dev/null 2>&1
    bakiar_list $list ewl
    bakiar_list $list wl

    echo ""
    echo "smooth with ambcons_wl"
    ${bbobindir}/bamboo -mode rtk nrtk.json -post -itrs -smooth -pams ambcons_wl >/dev/null 2>&1
    bakiar_list $list ewl
    bakiar_list $list wl
    bakiar_list $list n1

    echo ""
    echo "smooth with ambcons_n1 and output atom"
    ${bbobindir}/bamboo -mode rtk nrtk.json -post -itrs -dia -iar -smooth -pams ambcons_n1 outAtom >/dev/null 2>&1

    echo "process done, remove trace file"
    rm ./trace/*
}

bakiar_list() {
    local IFS='' # let "while read line" remains space
    local list=$1
    local type=$2
    if [ ! -f $list ]; then
        echo "${list} not exist!"
        exit
    fi
    while read line; do
        if [ ${line:0:1} != " " ]; then
            continue
        fi
        sitr=${line:1:4}
        sitr_low=$(echo $sitr | tr '[A-Z]' '[a-z]')
        sitr_up=$(echo $sitr | tr '[a-z]' '[A-Z]')
        sitb=${line:6:4}
        sitb_low=$(echo $sitb | tr '[A-Z]' '[a-z]')
        sitb_up=$(echo $sitb | tr '[a-z]' '[A-Z]')
        baseline=$sitr_up-$sitb_up
        echo "backiar ${baseline} ${type}"
        ${bbobindir}/bamboo -mode backiar nrtk.json -post -file results/amb_file_backward_${baseline} -ambtype ${type} >/dev/null 2>&1
    done <${list}
}

main "$@"
